#define _WINSOCKAPI_      // Prevent winsock.h from being included
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Cyberpunk.h"
#include "Mixmaster.h"
#include "RemailerDlgs.h"
#include "Pgpmail.h"
#include "PgpFiles.h"
#include "Fileman.h"
//#include "CpkKeyWins.h"
#include "global.h"
#include "view.h"

AnsiString cretbuf;
//---------------------------------------------------------------------------
__fastcall TRemailerDoc::TRemailerDoc()
   : TStringList()
{
   Modified = OpenDoc = false;
}
//---------------------------------------------------------------------------
__fastcall TRemailerDoc::TRemailerDoc(AnsiString Docfile)
   : TStringList()
{
   if (FileExists(Docfile)) LoadFromFile(Docfile);
   Modified = OpenDoc = false;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkPasteFromClipboard()
{
   TMemo *m = new TMemo((TComponent*)NULL);
   m->Visible = false;
   m->Parent = AppMainForm;
   m->PasteFromClipboard();
   AnsiString paste = m->Lines->Text;
   delete m;
   return paste;
}
//---------------------------------------------------------------------------
bool __fastcall cpkdb_getnext(TStringList *key, TStrings *keylist)
{
   key->Clear();
   AnsiString keyline;
   while (keylist->Count && keylist->Strings[0].IsEmpty()) keylist->Delete(0);
   if (!keylist->Count) return false;

   while (keylist->Count)
   {
      keyline = keylist->Strings[0];
      key->Add(keyline); keylist->Delete(0);
      if (keyline==EndPgpPubKeyBlock)
         return true;
   }
   return false;
}
//---------------------------------------------------------------------------
void __fastcall CpkSortKeys(TStrings *Keys)
{
   TStringList *out = new TStringList();
   TStringList *key = new TStringList();
   while (cpkdb_getnext(key,Keys))
   {
      TStringList *keylines = new TStringList();
      keylines->Text = key->Text;
      out->AddObject(keylines->Strings[0],keylines);
   }
   Keys->Clear();
   out->Sorted = true;
   for (int i=0; i<out->Count; i++)
   {
      TStrings *next = dynamic_cast<TStringList*>(out->Objects[i]);
      if (next) { Keys->AddStrings(next); Keys->Add(""); }
   }
   delete key;
   delete out;
}
//---------------------------------------------------------------------------
/*AnsiString __fastcall CpkPasteFromClipboard()
{
   TMemo *m = new TMemo((TComponent*)NULL);
   m->Visible = false;
   m->Parent = AppMainForm;
   m->PasteFromClipboard();
   AnsiString paste = m->Lines->Text;
   delete m;
   return paste;
}*/
//---------------------------------------------------------------------------
AnsiString __fastcall CpkKeyDesc(TStrings *key)
{
   AnsiString fld,shrt,user,keid,line=key->Count?key->Strings[0]:s("");
   shrt = GetToken(0,line," ");
   user = GetToken(1,line," ");
   keid = GetToken(2,line," ");
   return shrt+" "+user+" "+keid;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkCrtDesc(AnsiString &keydesc)
{
   if (keydesc.Pos("  ")>0) return keydesc;
   AnsiString shrt,rest;
   shrt = GetToken(0,keydesc," ").LowerCase();
   rest = keydesc.SubString(shrt.Length()+1,256).Trim(); shrt += "            ";
   int len=10; if (shrt.SubString(1,1)=="#") len = 11;
   return shrt.SubString(1,len)+" "+rest;
}
//---------------------------------------------------------------------------
bool __fastcall CpkKeyDefinately(TStrings *ascii)
{
   int endkey=-1,beginkey=-1;
   for (int i=0; i<ascii->Count; i++)
   {
      if (ascii->Strings[i]==BeginPgpPubKeyBlock) beginkey = i; else
      if (ascii->Strings[i]==EndPgpPubKeyBlock)
      {
         endkey = i;
         break;
      }
   }
   return beginkey==2 && beginkey<endkey;
}
//---------------------------------------------------------------------------
bool __fastcall CpkGetNextKey(AnsiString &keydesc, TStrings *key, TStrings *keys)
{
   key->Clear();
   while (keys->Count)
   {
      while (keys->Count && !CpkRingLineOk(keys->Strings[0])) keys->Delete(0);
      if (keys->Count && CpkKeyDefinately(keys))
      {
         while (keys->Count)
         {
            AnsiString line=keys->Strings[0];
            key->Add(line); keys->Delete(0);
            if (line==EndPgpPubKeyBlock)
            {
               keydesc = CpkCrtDesc(CpkKeyDesc(key));
               return true;
            }
         }
         return false;
      }
   }
   return false;
}
//---------------------------------------------------------------------------
void __fastcall CpkBlockToKeysFull(TStrings *Block)
{
   if (!Block || !Block->Count) return;
   if (HasPgp())
   {
      Block->SetText(PgpArmorBlockToArmorKeysCpk(Block->Text.c_str()));
      CpkSortKeys(Block);
   }
}
//---------------------------------------------------------------------------
/*AnsiString __fastcall CpkRemLines(TStrings *CList)
{
   int p;
   AnsiString tmp,keyid,line,shrt,adrs,caps;//,clisttxt=MixDir()+CListTxt;
   TStringList *rems = new TStringList();
   if (CList==NULL && FileExists(clisttxt)) rems->LoadFromFile(clisttxt);
   else rems->Text = CList->Text;
   TStringList *lines = new TStringList();
   for (int r=0; r<rems->Count; r++)
   {
      line = rems->Strings[r].Trim();
      if (line.Pos("$remailer{")==1)
      {
         keyid = noCkeyfound;
         shrt = GetParam(1,line,"\"");
         caps = GetParam(3,line,"\"");
         adrs = GetParam(0,caps," ");
         caps = caps.SubString(adrs.Length()+2,512);
         while ((p=adrs.Pos("<"))>0 || (p=adrs.Pos(">"))>0) adrs.Delete(p,1);
         lines->Add(shrt+" "+adrs+" "+noCkeyfound+" "+caps);
      }
   }
   cretbuf = lines->Text;
   delete lines;
   delete rems;
   return cretbuf;
}
//---------------------------------------------------------------------------
bool __fastcall InType1(AnsiString &remailer, TStrings *list)
{
   bool ok = false;
   for (int i=0; i<list->Count; i++)
   {
      if (list->Strings[i]==remailer || list->Strings[i]=="#"+remailer)
      {
         ok = true;
         break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
/*bool __fastcall CpkGenType1()
{
   TCpkKeyList *cring = new TCpkKeyList(cringtxt);
   TRemailerDoc *type1 = new TRemailerDoc(ctyp1txt);
   CpkGenType1(type1,cring,save);
   delete cring;
   delete type1;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall CpkGenType1(TStrings *type1, TStrings *cring, bool savetodisk)
{
   AnsiString line;
   TStringList *lines = new TStringList();
   lines->Text = type1->Text; lines->Sorted = true;
   // remove all but disabled keys from type1.list
   int i=0; while (i<lines->Count)
   {
      line = lines->Strings[i];
      if (line.SubString(1,1)!="#") lines->Delete(i);
      else i++;
   }
   // add keys from pubring.asc
   if (cring) for (i=0; i<cring->Count; i++)
   {
      line = cring->Strings[i];
      if (!CpkRingLineOk(line)) continue;

      line = CpkCrtDesc(line);
      if (!InType1(line,lines))
         lines->Add(line);
   }
   // finish up
   type1->Text = lines->Text;
   if (savetodisk) SaveToFileBak(type1,ctyp1txt,STATSBAKCOPIES);
   delete lines;
   return true;
}*/
//---------------------------------------------------------------------------
bool __fastcall CpkRingLineOk(AnsiString &line)
{
   return GetParam(1,line," ").Pos("@")>0 && GetParam(2,line," ").Pos("0x")==1;
}
//---------------------------------------------------------------------------
bool __fastcall CpkListLineOk(AnsiString &wholeline)
{//0         1         2         3         4         5         6         7
 //012345678901234567890123456789012345678901234567890123456789012345678901
 //"redneck  config@redneck.gacracker.org     ###***##*###      :27 100.00%"
   int l=1; while (l<wholeline.Length() && wholeline[l]!=' ') l++;
   AnsiString line=wholeline.SubString(l,256).Trim();
   l=line.Length(); if (l<62) return false;
   bool ok = GetParam(0,line," ").Pos("@");
   if (ok) ok = line[l-10]==':';
   if (ok) ok = line[l-3]=='.';
   if (ok) ok = line[l]=='%';
 //sm(s(line[l])+"   "+s(l));
   return ok;
}
//---------------------------------------------------------------------------

