//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "KeyringWins.h"
#include "KeyringClrDlgs.h"
#include "KeyringDelDlgs.h"
#include "ImageMods.h"
#include "Mixmaster.h"
#include "HelpDlgs.h"
#include "ClipReply.h"
#include "FileWin.h"
#include "msgwins.h"
#include "fileman.h"
#include "wipedlgs.h"
#include "global.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma resource "*.dfm"
TCustomKeyWin *CustomKeyWin;
//---------------------------------------------------------------------------
// TCustomKey
//---------------------------------------------------------------------------
__fastcall TCustomKey::TCustomKey()
   : TStringList()
{
}
//---------------------------------------------------------------------------
__fastcall TCustomKey::TCustomKey(TCustomKey *key)
   : TStringList()
{
   enabled = key->enabled;
   Text = key->Text;
}
//---------------------------------------------------------------------------
__fastcall TCustomKey::TCustomKey(TStrings *key, bool Enabled)
   : TStringList()
{
   enabled = Enabled;
   Text = key->Text;
}
//---------------------------------------------------------------------------
__fastcall TCustomKey::~TCustomKey()
{
}
//---------------------------------------------------------------------------
bool __fastcall TCustomKey::Enabled()
{
   return fEnabled;
}
//---------------------------------------------------------------------------
void __fastcall TCustomKey::SetEnabled(bool enabled)
{
   fEnabled = enabled;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCustomKey::Description()
{
   return (Count>0?Strings[0]:s(""));
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCustomKey::Name()
{
   return (Count>0?GetToken(0,Strings[0]," "):s(""));
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCustomKey::Address()
{
   return (Count>0?GetToken(1,Strings[0]," "):s(""));
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCustomKey::KeyId()
{
   return (Count>0?GetToken(2,Strings[0]," "):s(""));
}
//---------------------------------------------------------------------------
// TCustomKeyList
//---------------------------------------------------------------------------
__fastcall TCustomKeyList::TCustomKeyList()
   : TStringList()
{
   Sorted = true;
   shrtLen = 0;
   addrLen = 0;
   modified = false;
}
//---------------------------------------------------------------------------
__fastcall TCustomKeyList::TCustomKeyList(AnsiString filename)
   : TStringList()
{
   Sorted = true;
   shrtLen = 0;
   addrLen = 0;
   LoadFromFile(filename);
   modified = false;
}
//---------------------------------------------------------------------------
__fastcall TCustomKeyList::TCustomKeyList(TCustomKeyList *keys)
   : TStringList()
{
   Sorted = true;
   shrtLen = 0;
   addrLen = 0;
   AddKeys(keys);
   modified = false;
}
//---------------------------------------------------------------------------
__fastcall TCustomKeyList::TCustomKeyList(TStrings *keys)
   : TStringList()
{
   Sorted = true;
   shrtLen = 0;
   addrLen = 0;
   AddKeys(keys);
   modified = false;
}
//---------------------------------------------------------------------------
__fastcall TCustomKeyList::TCustomKeyList(TCustomKey *key)
   : TStringList()
{
   Sorted = true;
   shrtLen = 0;
   addrLen = 0;
   AddKey(key);
   modified = false;
}
//---------------------------------------------------------------------------
__fastcall TCustomKeyList::~TCustomKeyList()
{
   for (int i=0; i<Count; i++)
      delete Objects[i];
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyList::Clear()
{
   for (int i=0; i<Count; i++)
      delete Objects[i];
   TStringList::Clear();
   modified = true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCustomKeyList::KeyDescription(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   return Strings[atPos];
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyList::SaveToFileBak(AnsiString &docname, int bakcopies)
{
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyList::LoadFromFile(AnsiString filename)
{
   Clear();
   TStringList *keys = new TStringList();
   if (FileExists(filename))
   {
      keys->LoadFromFile(filename);
      AddKeys(keys);
   }
   modified = false;
   delete keys;
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyList::LoadFromStrings(TStrings *keys)
{
}
//---------------------------------------------------------------------------
TCustomKey* __fastcall TCustomKeyList::Key(int atPos)
{
   if (atPos<0 || atPos>=Count) return NULL;
   return (TCustomKey*)Objects[atPos];
}
//---------------------------------------------------------------------------
bool __fastcall TCustomKeyList::FindKey(TCustomKey *key, int &pos)
{
   int idx = -1;
   for (int i=0; i<Count; i++)
      if (Key(i)->Strings[0]==key->Strings[0])
      {
         idx = i;
         break;
      }
   pos = idx;
   return idx>=0;
}
//---------------------------------------------------------------------------
int __fastcall TCustomKeyList::AddKeys(TCustomKeyList *keys)
{
   int c=0;
   for (int i=0; i<keys->Count; i++)
   {
      AddKey(keys->Key(i));
      modified = true;
      c++;
   }
   return c;
}
//---------------------------------------------------------------------------
int __fastcall TCustomKeyList::AddKeys(TStrings *keys)
{
   return 0;
}
//---------------------------------------------------------------------------
bool __fastcall TCustomKeyList::AddKey(TStrings *key)
{
   TCustomKey *KEY = new TCustomKey(key);
   AddKey(KEY);
   delete KEY;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TCustomKeyList::AddKey(TCustomKey *key)
{
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyList::EnableKey(int atPos, bool enable)
{
   if (atPos<0 || atPos>=Count) return;
   Key(atPos)->enabled = enable;
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyList::DeleteKey(int atPos)
{
   if (atPos<0 || atPos>=Count) return;
   delete Key(atPos);
   Delete(atPos);
   modified = true;
}
//---------------------------------------------------------------------------
// TCustomKeyWin
//---------------------------------------------------------------------------
__fastcall TCustomKeyWin::TCustomKeyWin(TComponent* Owner)
	: TForm(Owner)
{
   initdone = false;
   keynodes = new TList();
   newkeys = new TStringList();
   diskeys = new TStringList();
   cap = Caption; Caption = "Loading...";
   SaveBtn->Enabled = RefreshBtn->Enabled = false;
   bmpHideDis = new Graphics::TBitmap(); ImageMod->ImageList2->GetBitmap(0,bmpHideDis);
   bmpShowAll = new Graphics::TBitmap(); ImageMod->ImageList2->GetBitmap(1,bmpShowAll);
   bmpOrg = HideDisBtn->Bitmap;
   TreeView->Images = ImageMod->ImageList1;
   RequestBtn->Enabled = false;
   DeleteBtn->Enabled = false;
   EnableDisableBtn(false);
   checksave = true;
   SetHelpBtnPos();
   curkey = -1;
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   SetRedraw(this,0);
   LoadKeys();
   LoadTreeView();
   SetNothingSelected();
   SetRedraw(this,1);
   initdone = true;
   Caption = cap;
}
//---------------------------------------------------------------------------
__fastcall TCustomKeyWin::~TCustomKeyWin()
{
   HideDisBtn->Bitmap->Assign(bmpOrg);
   delete bmpHideDis;
   delete bmpShowAll;
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::LoadKeys()
{
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::SetHelpBtnPos()
{
   HelpBtn->Left = Width-58;
   HideDisBtn->Left = HelpBtn->Left-(HideDisBtn->Width+1);
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::SetNothingSelected()
{
   RequestBtn->Enabled = false;
   EnableDisableBtn(false);
   DeleteBtn->Enabled = false;
   curkey = -1;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::SetCount(bool clear)
{
   AnsiString cur,count;
   if (Application->Terminated) return;
   if (!clear && WindowState!=wsMinimized && keys->Count)
   {
      cur = curkey>=0?s(curkey+1)+"/":s("");
      count = cur+s(keys->Count);
   }
   AppMainForm->Perform(WM_SHOWSTATUS,1,(LPARAM)count.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::SetTreeItemBold(TTreeNode *ANode, bool Value,
   TTreeView *ATree)
{
   TTVItem item;
   int Template;
   if (!ANode) return;

   Template = Value ? -1 : 0;
   item.mask = TVIF_STATE;
   item.hItem = (HTREEITEM)ANode->ItemId;
   item.stateMask = TVIS_BOLD;
   item.state = item.stateMask & Template;
   TreeView_SetItem(ATree->Handle,&(TV_ITEM)item);
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::LoadTreeViewQuiet()
{
   int top=0;
   TTreeNode* node = TreeView->TopItem;
   if (node)
   {
      AnsiString topstr=node->Text;
      for (int i=0; i<keynodes->Count; i++)
         if (Node(i)->Text==topstr)
         {
            top = i;
            break;
         }
   }
   SetRedraw(this,0);
   LoadTreeView();
   if (top<keynodes->Count) TreeView->TopItem = Node(top);
   for (int i=0; i<3; i++) AppProcessMessages();
   SetRedraw(this,1);
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::LoadTreeView()
{
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::ClearTree()
{
   TreeView->Items->BeginUpdate();
   TreeView->Items->Clear();
   TreeView->Items->EndUpdate();
   keynodes->Clear();
   AppProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::EnableDisableBtn(bool enable)
{
   Graphics::TBitmap *bitmap=DisableBtn->Bitmap;
   TCanvas *canvas=bitmap->Canvas;
   SetRedraw(DisableBtn,0);
   if (enable)
   {
      for (int h=0; h<bitmap->Height; h++)
         for (int w=0; w<bitmap->Width; w++)
            if (canvas->Pixels[w][h]==clBlack) canvas->Pixels[w][h] = clBlue;
   }
   else
   {
      for (int h=0; h<bitmap->Height; h++)
         for (int w=0; w<bitmap->Width; w++)
            if (canvas->Pixels[w][h]==clBlue) canvas->Pixels[w][h] = clBlack;
   }
   DisableBtn->Enabled = enable;
   SetRedraw(DisableBtn,1);
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::FormClose(TObject *Sender, TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::FormResize(TObject *Sender)
{
   SetHelpBtnPos();
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::HideDisBtnClick(TObject *Sender)
{
   Caption = "Working...";
   hidedisabled = !hidedisabled;
   HideDisBtn->Bitmap->Assign(hidedisabled?bmpHideDis:bmpShowAll);
   ClearTree(); Sleep(100);
   LoadTreeView();//Quiet();
   PutAppIni(
      (keyringname=="Mixmaster"?MixHideDisabled:CpkHideDisabled),
      (hidedisabled?"1":"0")
   );
   Caption = cap;
}
//---------------------------------------------------------------------------
TTreeNode* __fastcall TCustomKeyWin::Node(int atPos)
{
   if (atPos<0 || atPos>=keynodes->Count) return NULL;
   return (TTreeNode*)keynodes->Items[atPos];
}
//---------------------------------------------------------------------------
TCustomKey* __fastcall TCustomKeyWin::NodeKey(int atPos)
{
   return NULL;
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::MakeMessage(TStrings *message, AnsiString &addrs,
   AnsiString &subject)
{
   TStringList *msg = new TStringList(); msg->Text = message->Text;
   for (int i=0; i<msg->Count; i++)
   {
      AnsiString tmpstr = msg->Strings[i];
      if (tmpstr.Pos("To:")==1) msg->Strings[i] = "To: "+addrs;
      if (tmpstr.Pos("Subject:")==1) msg->Strings[i] = "Subject: "+subject;
      if (tmpstr.IsEmpty()) break;
   }
   PutMessageOnDesktop(AppMainForm,msg);
   delete msg;
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::EnableKey(int atPos, bool enable)
{
   if (atPos<0 || atPos>=keynodes->Count) return;

   TTreeNode* node = Node(atPos);
   TCustomKey *key = (TCustomKey*)node->Data;
   key->enabled = enable;
   if (enable)
   {
      node->ImageIndex = 0; node->SelectedIndex = 0;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }
   else
   {
      node->ImageIndex = 1; node->SelectedIndex = 1;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }

   RECT r = { 0,0,50,2000 };
   InvalidateRect(TreeView->Handle,&r,false);
   keys->modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::DeleteKey(int atPos)
{
   if (curkey<0 || curkey>=keynodes->Count) return;
   if (KeyringDeleteKey(AppMainForm,keyringname))
   {
      RefreshBtn->Enabled = SaveBtn->Enabled = true;
      int pos; if (keys->FindKey(NodeKey(curkey),pos))
          keys->DeleteKey(pos);
      LoadTreeViewQuiet();
      SetNothingSelected();
   }
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::AddKeysImport(TCustomKeyList *NewKeys)
{
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::DeleteBtnClick(TObject *Sender)
{
   DeleteKey(curkey);
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::SaveKeys()
{
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::TreeViewMouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
   THitTests HitTest = TreeView->GetHitTestInfoAt(X, Y);
   if (HitTest.Contains(htOnIcon))
      DisableBtnClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::DisableBtnClick(TObject *Sender)
{
   if (curkey>=0) EnableKey(curkey,!NodeKey(curkey)->enabled);
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::TreeViewChange(TObject *Sender, TTreeNode *Node)
{
   int node0 = Node->Level==0;
   RequestBtn->Enabled = node0;
   EnableDisableBtn(node0);
   DeleteBtn->Enabled = node0;
   curkey = Node->Index;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::OkBtnClick(TObject *Sender)
{
   checksave = false;
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (keys->modified)
   {
      if (checksave)
      {
         switch (MsgBox("Your keyring is modified.\n\nSave your changes?",
            "Confirm",MB_YESNOCANCEL))
         {
            case IDCANCEL: CanClose = false;
            case IDNO: break;
            default:
               SaveKeys();
         }
      }
      else SaveKeys();
   }
   SetCount(true);
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::PopExpandItemClick(TObject *Sender)
{
   TreeView->FullExpand();
   if (keynodes->Count) TreeView->TopItem = (TTreeNode*)keynodes->Items[0];
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::PopCollapseItemClick(TObject *Sender)
{
   TreeView->FullCollapse();
   if (keynodes->Count) TreeView->TopItem = (TTreeNode*)keynodes->Items[0];
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::SaveBtnClick(TObject *Sender)
{
   SaveKeys();
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::ClearAllBtnClick(TObject *Sender)
{
   bool clrall;
   if (KeyringClearKeys(AppMainForm,keyringname,clrall))
   {
      int i=0; while (i<keys->Count)
      {
         if (clrall || keys->Key(i)->enabled) keys->DeleteKey(i);
         else i++;
      }
      if (hidedisabled && !clrall) HideDisBtn->Click(); // handles LoadTreeView();
      else LoadTreeView();
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
      SetNothingSelected();
   }
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::RefreshBtnClick(TObject *Sender)
{
   if (keys->modified && MsgBox(
      s("Your keyring is modified. Refresh from disk will discard your changes?\n\n")+
      s("Refresh now?"),
      s("Confirm"),
      MB_OKCANCEL)==IDCANCEL) return;

   SaveBtn->Enabled = RefreshBtn->Enabled = false;
   AnsiString cap = Caption;
   Caption = "Loading...";
   LoadKeys();
   newkeys->Clear();
   LoadTreeView();
   ClearAllBtn->Enabled = keys->Count>0 ? true:false;
   SetNothingSelected();
   Caption = cap;
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::RemailerDocItemClick(TObject *Sender)
{
   AnsiString doc; int d;
   TMenuItem *item = dynamic_cast<TMenuItem*>(Sender);
   if (item)
   {
      doc = MixDir()+item->Caption;
      while ((d=doc.Pos("&"))>0) doc.Delete(d,1);
      if (FileExists(doc)) EditTextFile(doc);
   }
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::RemailerConfigItemClick(TObject *Sender)
{
   TMenuItem *item=dynamic_cast<TMenuItem*>(Sender);
   if (item)
   {
      AnsiString remaddrs,subject,TempName;
      if (TreeView->Selected) remaddrs = TreeView->Selected->Text;
      remaddrs = GetParam(1,remaddrs," "); if (remaddrs.IsEmpty()) return;
      TStringList *temps = new TStringList();
      GetAppData(temps,UserTemplates);
      if (temps->IndexOf("config-request")>=0) TempName = "config-request";
      if (TempName.IsEmpty()) TempName =
          GetTemplateName("Select Template For Remailer Config-Request",modeMessage);
      if(!TempName.IsEmpty())
      {
         AnsiString cap = Caption; Caption = "Queueing message(s)...";
         TStringList *Template = new TStringList();
         GetAppData(Template,UserTemplates+PS+TempName);
         switch (item->Tag)
         {
            case 2:
               MakeMessage(Template,remaddrs,"remailer-config");
               break;
            case 3:
               MakeMessage(Template,remaddrs,"remailer-key"   );
               break;
            case 4:
               MakeMessage(Template,remaddrs,"remailer-help"  );
               break;
            case 5:
               MakeMessage(Template,remaddrs,"remailer-stats" );
               break;
            default:
               MakeMessage(Template,remaddrs,"remailer-config");
               MakeMessage(Template,remaddrs,"remailer-key"   );
               MakeMessage(Template,remaddrs,"remailer-help"  );
               MakeMessage(Template,remaddrs,"remailer-stats" );
               break;
         }
         AppMainForm->Perform(WM_QUEUECHANGE,0,NULL);
         AppMainForm->Perform(WM_SHOWSTATUS,0,
            (LPARAM)"Config-request(s) created and queued");
         delete Template;
         Sleep(200);
         Caption = cap;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::FormActivate(TObject *Sender)
{
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::ImportBtnClick(TObject *Sender)
{
   //
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::GetKeyringMenuDat(KeyringMenuDat *menudat)
{
  //KeyringMenuDat *menudat = (KeyringMenuDat*)Msg.LParam;
  bool hassel = curkey>=0;
  menudat->Modified = keys->modified;
  menudat->HasSel = hassel;
  menudat->RefreshEnabled = PopRefreshItem->Enabled;
  menudat->CurEnabled = hassel ? keys->Key(curkey)->enabled : false;
  menudat->IsPair = false;
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::WMSaveBtnClicked(TMessage& Msg)
{
   SaveBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::WMRefreshBtnClicked(TMessage& Msg)
{
   RefreshBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::WMImportBtnClicked(TMessage& Msg)
{
   ImportBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::WMDisableBtnClicked(TMessage& Msg)
{
   DisableBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::WMDeleteBtnClicked(TMessage& Msg)
{
   DeleteBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TCustomKeyWin::HelpBtnClick(TObject *Sender)
{
   //
}
//---------------------------------------------------------------------------
