//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "pgpsdk.h"
#include "global.h"
#include "pgpmail.h"
#include "pgpfiles.h"
#include "pgpbuffers.h"
#include "fmxutils.h"
#include "fileman.h"
#include "view.h"
HINSTANCE hPgpSdk=NULL;
#define DEFKEYS NULL
//---------------------------------------------------------------------------
bool  __fastcall HasSdk()
{
   return hPgpSdk!=NULL;
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkInit(HWND owner, HWND apphandle)
{
   bool ok=true;
   PGPQDKINIT pgpinit;
   if ((pgpinit = (PGPQDKINIT)GetProcAddress(hPgpSdk,"@PGPqdkInit"))!=NULL)
      ok = (pgpinit)(owner,apphandle);
   if (!ok && hPgpSdk)
   {
      FreeLibrary(hPgpSdk);
      hPgpSdk = NULL;
   }
   return ok;
}
//---------------------------------------------------------------------------
char* __fastcall GetQdkLibName()
{
   GETQDKLIBNAME getqdklibname;
   if ((getqdklibname = (GETQDKLIBNAME)GetProcAddress(hPgpSdk,"@GetQdkLibName"))!=NULL)
      return (getqdklibname)();
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall GetQdkLibVersion()
{
   GETQDKLIBVERSION getqdklibversion;
   if ((getqdklibversion = (GETQDKLIBVERSION)GetProcAddress(hPgpSdk,"@GetQdkLibVersion"))!=NULL)
      return (getqdklibversion)();
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall PGPqdkPubringpkr()
{
   PGPQDKPUBRING qdkpub;
   if ((qdkpub=(PGPQDKPUBRING)GetProcAddress(hPgpSdk,"@PGPqdkPubringpkr"))!=NULL)
      return AnsiString((qdkpub)());
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall PGPqdkSecringskr()
{
   PGPQDKSECRING qdksec;
   if ((qdksec=(PGPQDKSECRING)GetProcAddress(hPgpSdk,"@PGPqdkSecringskr"))!=NULL)
      return AnsiString((qdksec)());
   return "";
}
//---------------------------------------------------------------------------
void __fastcall PGPqdkCleanup()
{
   PGPQDKCLEANUP pgpdone;
   if ((pgpdone=(PGPQDKCLEANUP)GetProcAddress(hPgpSdk,"@PGPqdkCleanup"))!=NULL)
      (pgpdone)();
}
//---------------------------------------------------------------------------
char*__fastcall PGPqdkExportCompat5(HWND Owner)
{
   PGPQDKEXPORTCOMPAT5 exp5;
   if ((exp5=(PGPQDKEXPORTCOMPAT5)GetProcAddress(hPgpSdk,"@PGPqdkExportCompat5"))!=NULL)
       return (exp5)(Owner);
   return NULL;
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkCheckPGP6NeedsUpdate(TForm *Owner, TControl *ForHourGlass)
{
   if (!PGP6AUTOUPDATE) return false;

   int QDKpub = FileAge(PGPqdkPubringpkr()); // QDK = sdk keyrings
   int PGPpub = FileAge(PgpPublicRing());    // quicksilver keyrings
   int QDKsec = FileAge(PGPqdkSecringskr());
   int PGPsec = FileAge(PgpSecretRing());
   if (QDKpub<0 || QDKsec<0) return false;   // -1 returned if file does not exist
   if (PGPpub<0 || PGPsec<0 || QDKpub>PGPpub || QDKsec>PGPsec)
   {
      PGPqdkUpdateQSKeyrings(Owner,ForHourGlass);
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkUpdateQSKeyrings(TForm *Owner, TControl *ForHourGlass)
{
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"Updating PGP keyrings on disk...");
   if (ForHourGlass) ForHourGlass->Cursor = crHourGlass;
   TStringList *block = new TStringList();
   block->SetText(PGPqdkExportCompat5(Owner->Handle));
   if (!block->Count)
   {
      if (ForHourGlass) ForHourGlass->Cursor = crDefault;
      MsgBoxHwnd(Owner->Handle,"Failed to import keys!","File Error",MB_OK);
      return false;
   }

   if (block->Strings[0].Pos("-----BEGIN PGP")==1)
   {
      TPGPbuffer *secrets,*publics,*newkeys,*pubs,*secs,*key,*chk,*pkt,*pub;
      AnsiString rids,dids,id,ids=block->Strings[block->Count-1];
      rids = GetToken(0,ids,"|"); dids = GetToken(1,ids,"|");

      pkt = new TPGPbuffer();
      pub = new TPGPbuffer();
      key = new TPGPbuffer();
      chk = new TPGPbuffer();
      secrets = new TPGPbuffer();
      publics = new TPGPbuffer();
      newkeys = new TPGPbuffer(block);
      // dispurse to publics and secrets
      while (key->copykeyfrom(newkeys,REWIND))
      {
         if (key->ispublic)
         {
            // add undefined trust packets back to keys
            while (pkt->copypacketfrom(key,REWIND))
            {
               pub->copyfrom(pkt);
               byte keytrust[3] = { 176,1,0 };
               byte sigtrust[3] = { 176,1,0 };
               byte uidtrust[3] = { 176,1,0 };
               if (PublicKeyPacket(pkt->CTB)) pub->Write(keytrust,3); else
               if (SignaturePacket(pkt->CTB)) pub->Write(sigtrust,3); else
               if (UserIdPacket(pkt->CTB)) pub->Write(uidtrust,3);
               pkt->Clear();
            }
          //if (rids.Pos("0x"+pub->idtext8)>=1) pub->revoke();
            if (dids.Pos("0x"+pub->idtext8)>=1) pub->disable();
            if (rids.Pos("0x"+pub->idtext8)<1)
                publics->copyfrom(pub);
            pub->clear();
         }
         else
            secrets->copyfrom(key);
         key->clear();
      }
      // load publics and add to new keys if not already present
      TStringList *uids = new TStringList();
      uids->Duplicates = dupIgnore;
      publics->getuserids(uids);
      pubs = new TPGPbuffer(PgpPublicRing());
      while (key->copykeyfrom(pubs,REWIND))
      {  // this actions ends with unmatched current keys copied to publics which
         if (uids->IndexOf(key->idtext8)>=0) // becomes the new keyring
            publics->copyfrom(key);
         key->clear();
      }
      // load secrets and add to new keys if not already present
      uids->Text = secrets->getuserids();
      secs = new TPGPbuffer(PgpSecretRing());
      while (key->copykeyfrom(secs,REWIND))
      {
         if (uids->IndexOf(key->idtext8)>=0)
            secrets->copyfrom(key);
         key->clear();
      }
      // save new keyrings to file
      publics->SaveToFile(PgpPublicRing());
      secrets->SaveToFile(PgpSecretRing());
    //BufSaveToFileBak(secrets->data,secrets->length,PgpSecretRing(),KEYRINGBAKCOPIES);
    //BufSaveToFileBak(publics->data,publics->length,PgpPublicRing(),KEYRINGBAKCOPIES);
      delete secs;
      delete pubs;
      delete key;
      delete chk;
      delete pub;
      delete pkt;
   }
   delete block;
   //reverse earlier visual cues
   if (ForHourGlass) ForHourGlass->Cursor = crDefault;
   //if (Owner) Owner->Caption = cap;
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"QuickSilver keyrings updated");
   return true;
}
//---------------------------------------------------------------------------
/*bool __fastcall PGPqdkSaveQSKeysToPGP6(HWND Owner)
{
// probably flawed function - unused
   TPGPbuffer *pdb,*sdb;
   TStringList *deletes,*pub,*sec;
   if (FileExists(deletespgp))
   {
      deletes = new TStringList();
      deletes->LoadFromFile(deletespgp);
      if (deletes->Count && !PGPqdkDeleteKeys(Owner,DEFKEYS,deletes->Text.c_str()))
      {
         delete deletes;
         return false;
      }
      DeleteFile(s(deletespgp).c_str());
      delete deletes;
   }

   pdb = new TPGPbuffer(PgpPublicRing());
   sdb = new TPGPbuffer(PgpSecretRing());
   pub = new TStringList();
   sec = new TStringList();

   pdb->export(pub);
   sdb->export(sec);
   pub->AddStrings(sec);
   bool ok=PGPqdkImportKeys(Owner,DEFKEYS,pub->Text.c_str());

   delete sec;
   delete pub;
   delete sdb;
   delete pdb;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkUpdateQSKeyringsOld(TForm *Owner, TControl *ForHourGlass)
{
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"Updating PGP keyrings on disk...");
   if (ForHourGlass) ForHourGlass->Cursor = crHourGlass;
   if (!PGPqdkCopyCompat5(Owner->Handle,PgpPublicRing().c_str(),PgpSecretRing().c_str()))
   {
      if (ForHourGlass) ForHourGlass->Cursor = crDefault;
      MsgBoxHwnd(Owner->Handle,"Failed to import keys!","File Error",MB_OK);
      return false;
   }
   //remove backup keyrings PGP6 maintains it's own
   TStringList *tmp =new TStringList();
   TStringList *files=new TStringList();
   AnsiString QSKeyringPath = ExtractFilePath(PgpPublicRing());
   GetFilenames(files,QSKeyringPath+"pubring-bak-*.*",faAnyFile);
   GetFilenames(tmp,QSKeyringPath+"secring-bak-*.*",faAnyFile);
   files->AddStrings(tmp);
   for (int i=0; i<files->Count; i++)
      DeleteFile(files->Strings[i].c_str());
   delete files;
   delete tmp;
   //reverse earlier visual cues
   if (ForHourGlass) ForHourGlass->Cursor = crDefault;
   //if (Owner) Owner->Caption = cap;
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"QuickSilver keyrings updated");
   return true;
}
//---------------------------------------------------------------------------
// Imported QSpgp6.dll functions
//---------------------------------------------------------------------------
bool __fastcall PGPqdkInit(HWND owner, HWND apphandle)
{
   bool ok=true;
   PGPQDKINIT pgpinit;
   if ((pgpinit = (PGPQDKINIT)GetProcAddress(hPgpSdk,"@PGPqdkInit"))!=NULL)
      ok = (pgpinit)(owner,apphandle);
   if (!ok && hPgpSdk)
   {
      FreeLibrary(hPgpSdk);
      hPgpSdk = NULL;
   }
   return ok;
}
//---------------------------------------------------------------------------
void __fastcall PGPqdkCleanup()
{
   PGPQDKCLEANUP pgpdone;
   if ((pgpdone=(PGPQDKCLEANUP)GetProcAddress(hPgpSdk,"@PGPqdkCleanup"))!=NULL)
      (pgpdone)();
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkCopyCompatible5(HWND owner, char *pubring, char *secring)
{
   PGPQDKCOPYCOMPAT5 copy5;
   if ((copy5=(PGPQDKCOPYCOMPAT5)GetProcAddress(hPgpSdk,"@PGPqdkCopyCompatible5"))!=NULL)
       return (copy5)(owner,pubring,secring);
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkCopyCompat5(HWND owner, char *pubring, char *secring)
{
   PGPQDKCOPYCOMPAT5 copy5;
   if ((copy5=(PGPQDKCOPYCOMPAT5)GetProcAddress(hPgpSdk,"@PGPqdkCopyCompat5"))!=NULL)
       return (copy5)(owner,pubring,secring);
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkEnableKeys(HWND Owner, PGPKeySetRef keys, char *HexID)
{
   PGPQDKENABLEKEYS ablekeys;
   if ((ablekeys=(PGPQDKENABLEKEYS)GetProcAddress(hPgpSdk,"@PGPqdkEnableKeys"))!=NULL)
       return (ablekeys)(Owner,keys,HexID);
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkDeleteKeys(HWND Owner, PGPKeySetRef keys, char *HexID)
{
   PGPQDKDELETEKEYS delkeys;
   if ((delkeys=(PGPQDKDELETEKEYS)GetProcAddress(hPgpSdk,"@PGPqdkDeleteKeys"))!=NULL)
       return (delkeys)(Owner,keys,HexID);
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkImportKeys(HWND Owner, PGPKeySetRef keys, char *asciiblock)
{
   PGPQDKIMPORTKEYS impkeys;
   if ((impkeys=(PGPQDKIMPORTKEYS)GetProcAddress(hPgpSdk,"@PGPqdkImportKeys"))!=NULL)
       return (impkeys)(Owner,keys,asciiblock);
   return false;
}
//---------------------------------------------------------------------------
char*__fastcall PGPqdkExportKeys(HWND Owner, PGPKeySetRef keys, char *HexIDs,
   PGPExportFormat &ExpFormat, bool IncludePrivates)
{
   PGPQDKEXPORTKEYS expkeys;
   if ((expkeys=(PGPQDKEXPORTKEYS)GetProcAddress(hPgpSdk,"@PGPqdkExportKeys"))!=NULL)
       return (expkeys)(Owner,keys,HexIDs,ExpFormat,IncludePrivates);
   return NULL;
}*/
//---------------------------------------------------------------------------
